﻿Imports System.Windows.Media
Imports ionDESK.Abstracts
Imports ionDESK.Addin
Imports System.Windows

'Make your add-in locatable

'At startup, ionDESK scans for add-ins to use within the current users work session. It scans for add-ins in the following directories :
'ExeFolder \ Data \ Common \ StrategyCenter \ Final \ Addins \ [  My Add-in Folder  ] \ [ MyCustomAddin.ISL.DLL ] 
'ExeFolder \ Addins \ [  My Add-in Folder  ] \ [ MyCustomAddin.ISL.DLL ] 



Partial Public Class Tester
    Inherits ionDESK.Addin.AddInPlatformWindow

    Public Overrides ReadOnly Property Icon As ImageSource
        Get
            Return (New ImageSourceConverter).ConvertFromString("/Resources/Graphics/Tester.png")
            'Return (New ImageSourceConverter).ConvertFromString("pack://application:,,/Resources/Graphics/Tester.png")
        End Get
    End Property
    Private _AddinClassInfo As AddinClassInfo
    Public Overrides ReadOnly Property AddinInfo As Addin.AddinClassInfo
        Get
            If _AddinClassInfo Is Nothing Then
                _AddinClassInfo = New AddinClassInfo
                With _AddinClassInfo

                    ' Place a unique GUID here for each add-in you create. DONT JUST CHANGE ID by hand, use a GUID generator
                    .UniqueGUID = "00000000-0000-0000-0000-000000000006"

                    .Title = WindowSetup.Title

                    .AddinType = AddinClassInfo.EnumAddinType.PlatformWindow

                    ' Add a URL to Quick Info Help
                    .QuickInfoURL = "http://www.mydomain.com/mypath/myhtmlfile.htm"

                    ' Set release date
                    .Released = CDate("1/1/2013")

                    'See addin help for more details to define the AddinClassInfo class

                End With
            End If




            Return _AddinClassInfo
        End Get
    End Property
    Private _Toolsetup As Abstracts.WindowsSetup
    Public Overrides ReadOnly Property WindowSetup As Abstracts.WindowsSetup
        Get
            If _Toolsetup Is Nothing Then
                _Toolsetup = New Abstracts.WindowsSetup
                With _Toolsetup
                    .Width = 300
                    .Height = 300
                    .MinHeight = 300
                    .MinWidth = 300
                    .CanResize = False
                    .SavesToLayout = True
                    .Title = "Test Custom Order Window"
                End With
            End If

            Return _Toolsetup
        End Get
    End Property

    Private Sub Button1_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles Button1.Click

        If Not IsNumeric(Shares.Text) Then
            MessageBox.Show("Please enter shares as a number.")
            Exit Sub
        End If


        Dim o As New Order

        With o
            .Quote.symbol = Symbol.Text
            .orderedQuantity = CType(Shares.Text, Integer)
            .priceType = OrderBase.EnumPriceType.MARKET
            .orderAction = OrderBase.enumOrderAction.BUY
            .orderTerm = OrderBase.EnumOrderTerm.GOOD_UNTIL_CANCEL
            .accountID = o.GetPracticeAccountID() '00000000  'practice account 8 ZEROS

        End With


        If o.IsValid Then
            ionDESK.Order.PlaceOrder(o)
            MessageBox.Show("Order was placed!")
        Else
            MessageBox.Show("Order was not placed! " & o.Errors(0).Problem)
        End If


    End Sub
End Class
