﻿Imports ionDESK.Abstracts

Imports ionDESK.Addin
Imports System.Windows.Media
Imports System.Drawing
Imports System.Windows.Shapes
Imports ionDESK.Addin.SignalOutputItem
Imports System.Drawing.Drawing2D
Imports System.Reflection
Imports ionDESK.Data
Imports ionDESK.Attributes
Imports System.ComponentModel.DataAnnotations
Imports System.Windows
Imports System.ComponentModel


'Make your add-in locatable

'At startup, ionDESK scans for add-ins to use within the current users work session. It scans for add-ins in the following directories :
'ExeFolder \ Data \ Common \ StrategyCenter \ Final \ Addins \ [  My Add-in Folder  ] \ [ MyCustomAddin.ISL.DLL ] 
'ExeFolder \ Addins \ [  My Add-in Folder  ] \ [ MyCustomAddin.ISL.DLL ] 



' ---Quote Signals ---
' Addins used to signal buy / sell signals based on quote based mathematics

<Serializable()> Public Class Quote_Signal_TemplateInput
    Inherits QuoteSignalInput


    ' Part one
    ' ionDESK's addin structure is very simple and consistant. 
    ' It is based on one class for user input/configuration and a processing class
    ' in the example template we have one input template and one processing class
    ' We suggest placing both classes in the same file per each addin.


    Public Enum EnumSignalSampleType
        Bullish = 0
        Bearish = 1
    End Enum

    ' You can add a Form separator to separate the areas of the configuration form
    <FormSeparator>
       <DisplayAttribute(Description:="Describe your setting.")>
    Public Property Setting_1 As Decimal


    <DisplayAttribute(Description:="Describe your setting.")>
    Public Property Setting_2 As String


    ' Note enumerations turn into combo list on the configuration form
    <DisplayAttribute(Description:="Describe your setting.")>
    Public Property Setting_3 As EnumSignalSampleType = EnumSignalSampleType.Bullish


    ' Override : To display sub title with setting value included.
    Public Overrides ReadOnly Property SubTitle As String
        Get
            Return (Symbol & String.Format(" a({0}) b({1}) c({2})", Setting_1, Setting_2, Setting_3.ToString)).Trim
        End Get

    End Property

    ' Error check here
    Public Overrides Function IsValid() As Boolean
        Me.Errors.Clear()


        Return MyBase.IsValid()
    End Function


End Class


' PPOCESS CLASS - ionDESK class used to process and generate output based on the users input 
' The Process Class aslo contain the 'AddinClassInfo' property that defines the addin and other specifiers

<Serializable()> Public Class Quote_Signal_Template
    Inherits QuoteSignalBase

    Public Overrides ReadOnly Property AddinInfo As AddinClassInfo
        Get
            Dim a As New AddinClassInfo
            With a
                .Title = "[i] Quote Signal Template"
                .Description = "Describe Signal."

                ' Place a unique GUID here for each add-in you create. DONT JUST CHANGE ID by hand, use a GUID generator
                .UniqueGUID = "00000000-0000-0000-0000-000000000003"

                ' Set Addin Type
                .AddinType = AddinClassInfo.EnumAddinType.QuoteSignal

                ' Add a URL to Quick Info Help
                .QuickInfoURL = "http://www.mydomain.com/mypath/myhtmlfile.htm"

                ' Set release date
                .Released = CDate("1/1/2013")

                'See addin help for more details to define the AddinClassInfo class


            End With
            Return a
        End Get
    End Property


    Public Overloads Function GetData(e As Quote_Signal_TemplateInput) As QuoteSignalOutput
        Dim t As New QuoteSignalOutput

        ' We set the initial signal to Neutral
        t.Data.SignalType = EnumSignalType.Neutral


        If Not e.IsValid Then
            t.Errors.Clear()
            t.Errors.Add(e.Errors)
            If Not t.Errors.HasErrors Then t.Errors.Add("Check input")
            Return t
        End If

        Dim d = e.ionDESK.Data.Quote(e.Symbol)


        If d.IsDataReady Then
            ' Perform some calculation here to determine if signal is good or not

            If d.lastTrade > 10 Then ' some arbitrary condition
                t.Data.SignalType = EnumSignalType.Buy
            End If


        Else
            t.Errors.Add("Data not ready!")
        End If


        d = Nothing


        Return t
    End Function


End Class
