﻿Imports ionDESK.Abstracts
Imports ionDESK.Addin
Imports ionDESK.Addin.SignalOutputItem

Imports ionDESK.Data
Imports ionDESK.Attributes
Imports System.Reflection
Imports System.ComponentModel.DataAnnotations

Imports ionDESK.Data.HistoricalDataPoint

'Make your add-in locatable

'At startup, ionDESK scans for add-ins to use within the current users work session. It scans for add-ins in the following directories :
'ExeFolder \ Data \ Common \ StrategyCenter \ Final \ Addins \ [  My Add-in Folder  ] \ [ MyCustomAddin.ISL.DLL ] 
'ExeFolder \ Addins \ [  My Add-in Folder  ] \ [ MyCustomAddin.ISL.DLL ] 





' ---Triggers ---
' Addin which serves are custom triggers. Used as advanced replacements for common triggers like trails, stops etc.

' INPUT CLASS - ionDESK class used to gather user input / setting for the addin
<Serializable()> Public Class Trigger_Template_Input
    Inherits TriggerInput



    ' Part one
    ' ionDESK's addin structure is very simple and consistent. 
    ' It is based on one class for user input/configuration and a processing class
    ' in the example template we have one input template and one processing class
    ' We suggest placing both classes in the same file per each addin.



    ' You can add a Form separator to separate the areas of the configuration form
    <FormSeparator>
       <DisplayAttribute(Description:="Describe your setting.")>
    Public Property Setting_1 As Decimal


    <DisplayAttribute(Description:="Describe your setting.")>
    Public Property Setting_2 As String




    ' Override : To display sub title with setting value included.
    Public Overrides ReadOnly Property SubTitle As String
        Get
            Return (Symbol & String.Format(" c({0}) u({1}) ", Setting_1, Setting_2)).Trim
        End Get

    End Property

    ' Error check here
    Public Overrides Function IsValid() As Boolean
        Me.Errors.Clear()


        Return MyBase.IsValid()
    End Function




End Class



Public Class Trigger_Template
    Inherits TriggerBase

    Public Overrides ReadOnly Property AddinInfo As AddinClassInfo
        Get
            Dim a As New AddinClassInfo
            With a
                .Title = "Trigger Template"
                .Description = "Describe your addin here"

                ' Place a unique GUID here for each add-in you create. DONT JUST CHANGE ID by hand, use a GUID generator
                .UniqueGUID = "00000000-0000-0000-0000-000000000005"

                ' Place a unique GUID here for each add-in you create. DONT JUST CHANGE ID by hand, use a GUID generator
                .AddinType = AddinClassInfo.EnumAddinType.Trigger
      

                ' Add a URL to Quick Info Help
                .QuickInfoURL = "http://www.mydomain.com/mypath/myhtmlfile.htm"

                ' Set release date
                .Released = CDate("1/1/2013")

                'See addin help for more details to define the AddinClassInfo class




            End With
            Return a
        End Get
    End Property

    Public Overloads Function GetData(e As Trigger_Template_Input) As TriggerOutput

        Dim t As New TriggerOutput


        If Not e.IsValid Then
            t.Errors.Clear()
            t.Errors.Add(e.Errors)

            If Not t.Errors.HasErrors Then t.Errors.Add("Check input")

            Return t
        End If



        Dim h As HistoricalDataPointChain = e.ionDESK.Data.OHLC(e)
        Dim q As Quote = e.ionDESK.Data.Quote(e.Symbol)


        If h.IsDataReady And q.IsDataReady Then

            ' Place code here to determine if the trigger should fire to release the order leg
            ' All that is required is the line below

            t.PriceConditionMet = True


        Else
            t.Errors.Add("Data not ready!")
        End If




        Return t
    End Function



End Class
